#!/usr/bin/env python

import sys, string
from struct import *

def to_bin(val):
        ret = ""
        i = 0
        while i<32:
                i = i+1
                if (val & 1) == 1:
                        ret = "1" + ret
                else:
                        ret = "0" + ret
                val = val >> 1                      
                if (i % 8 == 0):
                        ret = " " + ret
        return ret

if len(sys.argv) == 2:
    filename = sys.argv[1]
else:
    print "no input file\n"
    sys.exit(1)

f = open(filename)
data = f.read()
f.close()

reg_map = (
  [0x000, "ID"               ],
  [0x140, "USBCMD"           ],
  [0x144, "USBSTS"           ],
  [0x148, "USBINTR"          ],
  [0x14C, "FRINDEX"          ],
  [0x154, "DEVICEADDR"       ],
  [0x158, "ENDPOINTLISTADDR" ],
  [0x15C, "ASYNCTTSTS"       ],
  [0x184, "PORTSC1"          ],
  [0x1A4, "OTGSC"            ],
  [0x1A8, "USBMODE"          ],
  [0x1AC, "ENDPTSETUPSTAT"   ],
  [0x1B0, "ENDPTPRIME"       ],
  [0x1BC, "ENDPTCOMPLETE"    ],
  [0x1C0, "ENDPTCTRL0"       ],
  )


f = "<%dL%dB" % (len(data)/4, len(data)%4)

a = unpack(f, data)

print "|--------|-------------------|----------------------------------------------------|"
print "| Offset | Register          | Value (hex) | Value (binary)                       |"
print "|--------|-------------------|-------------|--------------------------------------|"

for [offset, name] in reg_map:
        print "| 0x%04x | %-17s | 0x%08x  | %s | " % (offset, name, a[offset/4], to_bin(a[offset/4]))

